<template>
  <div>
    <h2>Change password</h2>
    <el-row>
      <el-col :sm="{span: 14, offset: 5}" :md="{span: 12, offset: 6}" :lg="{span: 10, offset: 7}">
        <el-form ref="form_password" :model="password" status-icon label-position="top">
          <el-form-item label="Current password" prop="currentPassword" :error="this.$data.errors.current_password">
            <el-input type="password" v-model="password.currentPassword"></el-input>
          </el-form-item>

          <el-form-item label="New password" prop="password"  :error="this.$data.errors.password">
            <el-input type="password" v-model="password.password"></el-input>
          </el-form-item>
          
          <el-form-item label="Password confirmation" prop="passwordConfirmation"  :error="this.$data.errors.password_confirmation">
            <el-input type="password" v-model="password.passwordConfirmation"></el-input>
          </el-form-item>
          
          <el-form-item>
            <el-button type="primary" @click="submitForm()">
              Save
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import gql from 'graphql-tag'

export default {
  data() {
    return {
      password: {
        currentPassword: '',
        password: '',
        passwordConfirmation: ''
      },
      errors: {
        current_password: '',
        password: '',
        password_confirmation: ''
      }
    }
  },
  
  methods: {
    submitForm() {
      this.$apollo.mutate({
        mutation: gql`mutation ($password: PasswordInput!) {
          updatePassword(password: $password) {
            success
            message
            errors { field message }
          }
        }`,
        variables: {
          password: this.$data.password
        },
        update: (store, { data: { updatePassword }}) => {
          if(updatePassword.success)
            this.$msgbox({ type: 'success', message: 'Password updated successfully' })
          else {
            this.$message.error('Failed to update password')
            updatePassword.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    }
  }
}
</script>
